require 'rlml'
$VERBOSE = true

data = 'rlml/latin1
foo {
  "data"
  bar {
    "bef\\"ore"
    quux { "this is just some stuff on  the *inside* -- wa :)" }
    quux { "$ as is % this # hehe" }
    "after" "can *you* mix?" "whoops"
  }
  he { he{ "zz"}}
  "foo   bar"
  "n \n t \t \" \\ passed\""
  (* what (* is *) "that?"
  t{"foo" (* comment *) "bar"}
  t{"foo"
    # comment
    "bar"}
  t{"foo bar"}
}
another { "yup" }
'

# data = 'rlml/iso-8859-1
#note
#{
#    to{"Tove"} from{"Jani"} heading{"Reminder"}
#    body{"Don\'t forget me this weekend!"}
#}
#'

# data = File.read("test01.rlml")

callback = Object.new

class << callback
  def method_missing(*args)
    p [*args]
  end
end

rlml = RLML::CoreParser.new(callback)
rlml.parse data

rlml2 = RLML::StreamParser.new(sw = RLML::StreamWriter.new(''))
rlml2.parse data
puts sw.output
rlml2 = RLML::StreamParser.new(RLML::StreamWriter.new(STDOUT))
rlml2.parse sw.output
puts

treep = RLML::TreeParser.new
tree = treep.parse(data)

p tree
tree.each { |elt|
  p elt.children
}

puts tree.to_s
puts tree.to_s("latin1")

# arch-tag: 64fdad03-2f65-4a94-9766-dd9da3d21156
